unit utMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, swSnmpM,winSnmp, Grids, ScktComp, ComCtrls, Buttons;

type
  TwinMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    btnGet: TButton;
    Memo3: TMemo;
    memErrState: TMemo;
    btnGetNext: TButton;
    swSnmpM1: TswSnmpM;
    Label4: TLabel;
    Label3: TLabel;
    edtIP: TEdit;
    Button3: TButton;
    memErrIndex: TMemo;
    Label5: TLabel;
    Label6: TLabel;
    Memo2: TMemo;
    btnSet: TButton;
    Memo4: TMemo;
    memSetErrState: TMemo;
    Label7: TLabel;
    memSetErrIndex: TMemo;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    edtRContext: TEdit;
    Label11: TLabel;
    edtWContext: TEdit;
    TabSheet3: TTabSheet;
    Memo7: TMemo;
    Label12: TLabel;
    Memo8: TMemo;
    Label13: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure swSnmpM1ReceiveMsg(Sender: TObject);
    procedure btnGetClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    sm : TswSnmpM;
  end;

var
  winMain: TwinMain;

implementation
{$R *.DFM}
procedure TwinMain.swSnmpM1ReceiveMsg(Sender: TObject);
var i,j  : Cardinal;
begin
  if PageControl1.ActivePageIndex = 0 then
  begin
     with (Sender as TswSnmpM) do
     begin
       if  Successful  then
       begin
           j := VBCount;
           for i := 0 to j-1  do
               memo1.Lines.Add(GetVBByList(1).Value);//del after every get , so always 1 !!!
           GetLastError(i,j);
           memErrState.Lines.add(IntToStr(i));
           memErrIndex.Lines.add(IntToStr(j));
       end;//end of if
     end;//end of wiht
  end
  else if PageControl1.ActivePageIndex = 1 then//set
  begin
     with (Sender as TswSnmpM) do
     begin
       if  Successful  then
       begin
           j := VBCount;
           for i := 0 to j-1  do
               memo2.Lines.Add(GetVBByList(1).Value);//del after every get , so always 1 !!!
           GetLastError(i,j);
           memSetErrState.Lines.add(IntToStr(i));
           memSetErrIndex.Lines.add(IntToStr(j));
       end;//end of if
     end;//end of wiht
  end;
end;

procedure TwinMain.btnGetClick(Sender: TObject);
begin
  swSnmpM1.DAddress := edtIP.Text;
  if ((sender as TButton).Name = 'btnSet') then
  begin
    swSnmpM1.method := smSet;
    swSnmpM1.Context := edtWContext.Text;
    swSnmpM1.VBList := Memo4.Lines ;
  end
  else
  if ((sender as TButton).Name = 'btnGet') then
  begin
    swSnmpM1.method := smGet;
    swSnmpM1.Context := edtRContext.Text;
    swSnmpM1.VBList := Memo3.Lines ;
  end
  else
  if ((sender as TButton).Name = 'btnGetNext') then
  begin
    swSnmpM1.method := smGetNext;
    swSnmpM1.Context := edtRContext.Text;
    swSnmpM1.VBList := Memo3.Lines ;
  end
  else exit;
  swSnmpM1.SendMsg;
end;

procedure TwinMain.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TwinMain.SpeedButton1Click(Sender: TObject);
begin
  Memo1.Clear;
  memErrState.Clear;
  memErrIndex.Clear;
end;

procedure TwinMain.SpeedButton2Click(Sender: TObject);
begin
  Memo2.Clear;
  memSetErrState.Clear;
  memSetErrIndex.Clear;
end;

end.
